"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var debug_helper_1 = require("../util/debug_helper");
var public_ws_handler_1 = require("./public_ws_handler");
var _a = debug_helper_1.default(__filename), debug = _a.debug, logError = _a.logError;
var authData = {
    method: "login",
    params: {
        algo: "BASIC",
        pKey: process.env.HITBTC_API_KEY,
        sKey: process.env.HITBTC_SECRET_KEY
    }
};
exports.getHitBTCPrivateObservableFromWS = function (subscriptionData, subscriptionId, unsubscriptionData) {
    var auth$ = public_ws_handler_1.getHitBTCPublicObservableFromWS(authData, "authRequest");
    var authSubscription = auth$.subscribe(function (_a) {
        var result = _a.result, error = _a.error;
        authSubscription.unsubscribe();
        debug({ result: result, error: error });
        if (error) {
            logError({ error: error });
            throw new Error(error);
        }
        if (result !== true)
            throw new Error('HitBTC WS auth error');
    }, function (authError) {
        logError({ authError: authError });
        throw new Error(authError);
    });
    return public_ws_handler_1.getHitBTCPublicObservableFromWS(subscriptionData, subscriptionId, unsubscriptionData);
};
