"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var qs_1 = require("qs");
var crypto_1 = require("crypto");
// Create a signature for a request
exports.getKrakenMessageSignature = function (path, params) {
    var message = qs_1.stringify(params);
    var secretBuffer = Buffer.from(process.env.KRAKEN_API_SECRET, 'base64');
    var hash = crypto_1.createHash('sha256');
    var hmac = crypto_1.createHmac('sha512', secretBuffer);
    var hashDigest = hash.update(params.nonce + message).digest('latin1');
    var hmacDigest = hmac.update(path + hashDigest, 'latin1').digest('base64');
    return hmacDigest;
};
